let addButton = document.getElementById("addPlayer");
let deleteButton = document.getElementById("removePlayer");
let changeTickButton = document.getElementById("changeTick");
let changeIdButton = document.getElementById("tickLeistenId");
let reloadButton = document.getElementById("reload");
let saveButton = document.getElementById("save");
var players = [];
let Id = Math.floor(Math.random()*10000000000000000).toString(16)
var ws = new WebSocket("ws:10.9.1.129:8080/" + Id);
document.getElementById("p4").innerHTML = "" + Id;


/* Handles Events from Server */
ws.onmessage = function(evt){
        var msg = evt.data;
        var obj = JSON.parse(msg);
        var valid = false;

        /*Changes Tick of one Player in players. Updates the Playerlist and current Player.*/
        if (obj.eventType == "SetPlayerTickE") {
            valid = true;
            for (i = 0; i < players.length; i++){
                if (players[i].UUID == obj.playerUUID){
                    players[i].Tick = obj.tick.tickValue;
                    var pl = players[i];
                    players.splice(i,1);
                    AddPlayer(pl);
                }
            }
            PlayerList();
            CurrentPlayer();
        }
        /*Adds Player and their Tick to players. Updates the Playerlist and current Player.*/
        if (obj.eventType == "AddPlayerTickE") {
            valid = true;
            var newPlayer = new Object ();
            newPlayer.Name = obj.playerName;
            newPlayer.UUID = obj.playerUUID;
            if (obj.tick.tickType == "Tick"){
            newPlayer.Tick = obj.tick.tickValue;
            }
            else {
            newPlayer.Tick = tickType;
            }
            AddPlayer(newPlayer);
            PlayerList();
            CurrentPlayer();
        }
        /*Adds players an their Ticks to players. Updates the Playerlist and current Player.*/
        if (obj.eventType == "InitializeTickLeisteE") {
            valid = true;
            players = [];
            for (i = 0; i<obj.tickLeiste.length;i++){
                for (j =0;j<obj.tickLeiste[i][1].length;j++ ){
                    AddPlayer({Tick: obj.tickLeiste[i][0].tickValue, UUID: obj.tickLeiste[i][1][j][0], Name: obj.tickLeiste[i][1][j][1]});
                }
            }
            PlayerList();
            CurrentPlayer();

        }
        /*Changes the Name of a Player in players. Updates the Playerlist and current Player*/
        if (obj.eventType == "ChangeNameE") {
            valid = true;
            for (i = 0; i < players.length; i++){
                if (players[i].UUID == obj.playerUUID){
                    players[i].Name = obj.playerName;
                }
            }
        PlayerList();
        CurrentPlayer();
        }
        /*Removes one Player from players. Updates the Playerlist and current Player*/
        if (obj.eventType == "RemovePlayerE") {
            valid = true;
            for (i = 0; i < players.length; i++){
                if (players[i].UUID == obj.playerUUID){
                    players.splice(i,1);
                }
            }
            PlayerList();
            CurrentPlayer();
        }
        /*If no eventType was recognized, an error is thrown.*/
        if (valid == false) {
            console.error('Invalid Event received');
        }
}



/*When the Button is clicked, a AddPlayerTickR request is send to the server.*/
addButton.onclick = function() {
                        var type = "";
                        if (document.getElementById("A2").value == "Abwarten") {
                            type = "Abwarten";
                        }
                        if (document.getElementById("A2").value == "Bereithalten") {
                            type = "Bereithalten";
                        }
                        else {
                            type = "Tick";
                        }
                        ws.send('{"requestType" : "AddPlayerTickR", "playerName" : "' + document.getElementById("A1").value + '"  , "tick" : {"tickType" : "' + type + '", "tickValue" : ' + document.getElementById("A2").value + '}}');
}

/*When the Button is clicked, a RemovePlayerR request is send to the server.*/
deleteButton.onclick = function() {
                        var UUID = "";
                        for (i = 0; i < players.length; i++){
                            if (players[i].Name == document.getElementById("B").value){
                                UUID = players[i].UUID;
                            }
                        }
                        ws.send('{"requestType" : "RemovePlayerR", "playerUUID" : "' + UUID + '"}');
                    }

/*When the Button is clicked, a SetPlayerTickR request is send to the server*/
changeTickButton.onclick = function() {
                        var UUID = "";
                        var Tick = document.getElementById("C2").value;
                        var type = "";
                        for (i = 0; i < players.length; i++){
                            if (players[i].Name == document.getElementById("C1").value){
                                UUID = players[i].UUID;
                                if (players[i].tick == "Abwarten" || players[i].tick == "Bereithalten"){
                                    type = players[i].Tick;
                                }
                                else {
                                    type = "Tick";
                                }
                            }
                        }
                        /*console.log(Tick);
                        console.log('{"requestType" : "SetPlayerTickR", "playerUUID" : "' + UUID + '", "tick" : {"tickType" : "' + type + '", "tickValue" : ' + Tick + '}}');*/
                        ws.send('{"requestType" : "SetPlayerTickR", "playerUUID" : "' + UUID + '", "tick" : {"tickType" : "' + type + '", "tickValue" : ' + Tick + '}}');
                     }

/*When the Button is clicked, a new WebSocket connection is opened with the new ID*/
changeIdButton.onclick = function() {
                        Id = document.getElementById("D").value;
                        ws.close();
                        ws = new WebSocket("ws:10.9.1.129:8080/" + Id);
                        document.getElementById("p4").innerHTML = "" + Id;
                    }

/*When the Button is clicked, a TickLeisteR request is send to the server.*/
reloadButton.onclick = function() {
                        ws.send('{"requestType" : "TickLeisteR"}');
                    }

saveButton.onclick = function(){ 
                        download("Tickleiste.json", JSON.stringify(players));
                    }


/*Updates the Playerlist according to the content of players.*/
function PlayerList(){
                        var content = "";
                        for (i = 0; i < players.length; i++){
                            content = content + players[i].Name + "  " + players[i].Tick + "<br>";
                        }
                        document.getElementById("p3").innerHTML = content;
                    }

/*Updates the current Player according to the Player with the smallest Tick in players.*/                        
function CurrentPlayer(){
                            document.getElementById("p2").innerHTML = players[0].Name;
                            document.getElementById("p1").innerHTML = "" + players[0].Tick;
                    }

function AddPlayer(player){
                        if (player.Tick == "Abwarten"){
                            players.push(player);
                        }
                        else {
                            if (player.Tick == "Bereithalten"){
                                for (i = players.length; i>0;i++){
                                    if (players[i-1].Tick != "Abwarten"){
                                        players.splice(i,0,player);
                                        break;
                                    }
                                }
                            }
                            else {
                                for (i = 0; i<players.length;i++){
                                    if (player.Tick < players[i].Tick){
                                        players.splice(i,0,player);
                                        break;
                                    }
                                }
                            }
                        }                        
                    }

function loadFile(input){
                        let file = input.files[0];

                        let reader = new FileReader();

                        reader.readAsText(file);

                        reader.onload = function() {
                            var pl = JSON.parse(reader.result);
                            var tickleiste = initializeJSONFormat(pl);
                            ws.send(tickleiste);
                        };
                        reader.onerror = function() {
                            console.log(reader.error);
                        };

                    }




function initializeJSONFormat(arr) {
                        var tick = -999;
                        var tickleiste = "";
                        var type = "";
                        for (i=0;i<arr.length;i++){
                            if (arr[i].Tick == "Abwarten" || arr[i].Tick == "Bereithalten"){
                                type = arr[i].Tick;
                            }
                            else {
                                type = "Tick";
                            }
                            if (arr[i].Tick > tick){
                                tick = arr[i].Tick;
                                tickleiste = tickleiste + ']], [{"tickType" : "' + type + '", "tickvalue" : "' + arr[i].Tick + '"}, ["' + arr[i].Name + '"';
                            }
                            else {
                                tick = arr[i].Tick;
                                tickleiste = tickleiste + ', "' + arr[i].Name + '"';
                            }

                        }
                        tickleiste = tickleiste.slice(4);
                        tickleiste = '{"requestType" : "InitializeTickLeisteR", "tickLeiste" : [' + tickleiste + ']]]}';
                        return tickleiste;

                    }

function download(filename, text) {
      var element = document.createElement('a');
      element.setAttribute('href', 'data:text/json;charset=utf-8,' + encodeURIComponent(text));
      element.setAttribute('download', filename);

      element.style.display = 'none';
      document.body.appendChild(element);

      element.click();

      document.body.removeChild(element);
}
